Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 4562)
+++ palm/trunk/SOURCE/Makefile	(revision 4564)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Vertical nesting method of Huq et al. (2019) removed
+# 
+# 4534 2020-05-14 18:35:22Z raasch
 # shared_memory_io_mod included and respective dependencies added
 # 
@@ -327,5 +330,4 @@
 	user_spectra.f90 \
 	vdi_internal_controls.f90 \
-	vertical_nesting_mod.f90 \
 	virtual_flight_mod.f90 \
 	virtual_measurement_mod.f90 \
@@ -453,6 +455,5 @@
 	netcdf_interface_mod.o \
 	pmc_interface_mod.o \
-	subsidence_mod.o \
-	vertical_nesting_mod.o
+	subsidence_mod.o
 chem_emissions_mod.o: \
 	chem_gasphase_mod.o \
@@ -715,6 +716,5 @@
 init_coupling.o: \
 	mod_kinds.o \
-	modules.o \
-	vertical_nesting_mod.o
+	modules.o
 init_grid.o: \
 	exchange_horiz_mod.o \
@@ -722,6 +722,5 @@
 	modules.o \
 	netcdf_data_input_mod.o \
-	netcdf_interface_mod.o \
-	vertical_nesting_mod.o
+	netcdf_interface_mod.o
 init_masks.o: \
 	bulk_cloud_model_mod.o \
@@ -735,6 +734,5 @@
 	pmc_interface_mod.o \
 	spectra_mod.o \
-	synthetic_turbulence_generator_mod.o \
-	vertical_nesting_mod.o
+	synthetic_turbulence_generator_mod.o
 init_pt_anomaly.o: \
 	exchange_horiz_mod.o \
@@ -787,6 +785,5 @@
 	mod_kinds.o \
 	modules.o \
-	pmc_interface_mod.o \
-	vertical_nesting_mod.o
+	pmc_interface_mod.o
 local_tremain.o: \
 	cpulog_mod.o \
@@ -935,6 +932,5 @@
 	progress_bar_mod.o \
 	read_restart_data_mod.o \
-	turbulence_closure_mod.o \
-	vertical_nesting_mod.o
+	turbulence_closure_mod.o
 plant_canopy_model_mod.o: \
 	bulk_cloud_model_mod.o \
@@ -1092,5 +1088,4 @@
 	surface_mod.o \
 	user_module.o \
-	vertical_nesting_mod.o \
 	virtual_measurement_mod.o
 restart_data_mpi_io_mod.o: \
@@ -1228,5 +1223,4 @@
 	turbulence_closure_mod.o\
 	urban_surface_mod.o \
-	vertical_nesting_mod.o \
 	virtual_flight_mod.o \
 	virtual_measurement_mod.o \
@@ -1253,6 +1247,5 @@
 	mod_kinds.o \
 	modules.o \
-	pmc_interface_mod.o \
-	vertical_nesting_mod.o
+	pmc_interface_mod.o
 timestep_scheme_steering.o: \
 	mod_kinds.o \
@@ -1357,10 +1350,4 @@
 	modules.o \
 	pmc_interface_mod.o
-vertical_nesting_mod.o: \
-	exchange_horiz_mod.o \
-	mod_kinds.o \
-	modules.o \
-	surface_mod.o \
-	turbulence_closure_mod.o
 virtual_flight_mod.o: \
 	basic_constants_and_equations_mod.o \
@@ -1414,4 +1401,3 @@
 	surface_mod.o \
 	user_module.o \
-	vertical_nesting_mod.o \
 	virtual_measurement_mod.o
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4562)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 4564)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4562 2020-06-12 08:38:47Z raasch
 ! bugfix: revised error message for exceeding allow number of time series
 ! 
@@ -191,11 +194,4 @@
 
     USE transpose_indices
-
-#if defined( __parallel )
-    USE vertical_nesting_mod,                                                                      &
-        ONLY:  vnested,                                                                            &
-               vnest_check_parameters
-#endif
-
 
     IMPLICIT NONE
@@ -247,6 +243,4 @@
          coupling_mode /= 'precursor_atmos'      .AND.                                             &
          coupling_mode /= 'precursor_ocean'      .AND.                                             &
-         coupling_mode /= 'vnested_crse'         .AND.                                             &
-         coupling_mode /= 'vnested_fine'         .AND.                                             &
          coupling_mode /= 'atmosphere_to_ocean'  .AND.                                             &
          coupling_mode /= 'ocean_to_atmosphere' )  THEN
@@ -302,5 +296,4 @@
 !-- Check dt_coupling, restart_time, dt_restart, end_time, dx, dy, nx and ny
     IF ( coupling_mode /= 'uncoupled'        .AND.                                                 &
-         coupling_mode(1:8) /= 'vnested_'    .AND.                                                 &
          coupling_mode /= 'precursor_atmos'  .AND.                                                 &
          coupling_mode /= 'precursor_ocean' )  THEN
@@ -478,8 +471,4 @@
     IF ( coupling_mode == 'uncoupled' )  THEN
        coupling_string = ''
-    ELSEIF ( coupling_mode == 'vnested_crse' )  THEN
-       coupling_string = ' nested (coarse)'
-    ELSEIF ( coupling_mode == 'vnested_fine' )  THEN
-       coupling_string = ' nested (fine)'
     ELSEIF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
        coupling_string = ' coupled (atmosphere)'
@@ -3058,10 +3047,4 @@
     ENDIF
 
-#if defined( __parallel )
-!
-!-- Vertical nesting: check fine and coarse grid compatibility for data exchange
-    IF ( vnested )  CALL vnest_check_parameters
-#endif
-
 !
 !-- Check if topography is read from file in case of complex terrain simulations
Index: palm/trunk/SOURCE/init_coupling.f90
===================================================================
--- palm/trunk/SOURCE/init_coupling.f90	(revision 4562)
+++ palm/trunk/SOURCE/init_coupling.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! ------------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -50,6 +53,4 @@
     
     USE pegrid
-
-    USE vertical_nesting_mod
 
     IMPLICIT NONE
@@ -84,6 +85,4 @@
        IF ( TRIM( coupling_mode ) == 'coupled_run' )  THEN
           i = 1
-       ELSEIF ( TRIM( coupling_mode ) == 'vnested_twi' )  THEN
-          i = 9
        ELSE
           i = 0
@@ -111,34 +110,4 @@
           CLOSE ( 90 )
        ENDIF
-    ELSEIF ( i == 9 )  THEN
-
-!
-!--    Set a flag to identify runs with vertical nesting
-       vnested = .TRUE.
-       
-       comm_inter = MPI_COMM_WORLD
-       
-!
-!--    Split the total available PE's into two groups
-!--    numprocs for coarse and fine grid are read from stdin (see above, and
-!--    execution command in the palmrun script, numprocs are provided via
-!--    palmrun option -Y)
-       IF ( myid < bc_data(1) )  THEN
-          inter_color     = 0
-          numprocs        = bc_data(1)
-          coupling_mode   = 'vnested_crse'
-       ELSE
-          inter_color     = 1
-          numprocs        = bc_data(2)
-          coupling_mode   = 'vnested_fine'
-       ENDIF
-       
-       CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, inter_color, 0, comm_palm, ierr )
-       comm2d = comm_palm
-       
-       OPEN( 90, FILE='VNESTING_PORT_OPENED', FORM='FORMATTED' )
-       WRITE ( 90, '(''TRUE'')' )
-       CLOSE ( 90 )
-      
     ELSE
        comm_inter = MPI_COMM_WORLD
@@ -174,9 +143,3 @@
     ENDIF
 
-    IF (  TRIM( coupling_mode ) == 'vnested_fine' )  THEN
-!
-!-- Set file extension for vertical nesting
-       coupling_char = '_NV'
-    ENDIF
-
  END SUBROUTINE init_coupling
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 4562)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4543 2020-05-20 14:12:22Z gronemeier
 ! Remove non-required check for canyon height
 ! 
@@ -184,9 +187,4 @@
 
     USE pegrid
-
-#if defined( __parallel )
-    USE vertical_nesting_mod,                                                  &
-        ONLY:  vnested, vnest_init_grid
-#endif
 
     IMPLICIT NONE
@@ -766,11 +764,4 @@
        ENDDO
     ENDIF
-
-#if defined( __parallel )
-!
-!-- Vertical nesting: communicate vertical grid level arrays between fine and
-!-- coarse grid
-    IF ( vnested )  CALL vnest_init_grid
-#endif
 
  END SUBROUTINE init_grid
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 4562)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4461 2020-03-12 16:51:59Z raasch
 ! communicator configurations for four virtual pe grids defined
 ! 
@@ -139,7 +142,4 @@
     USE transpose_indices,                                                     &
         ONLY:  nxl_yd, nxr_yd, nzb_yd, nzt_yd
-
-    USE vertical_nesting_mod,                                                  &
-        ONLY:  vnested, vnest_init_pegrid_domain, vnest_init_pegrid_rank
 #endif
 
@@ -357,9 +357,4 @@
 
 !
-!-- Vertical nesting: store four lists that identify partner ranks to exchange 
-!-- data
-    IF ( vnested )  CALL vnest_init_pegrid_rank
-
-!
 !-- Determine sub-topologies for transpositions
 !-- Transposition from z to x:
@@ -666,5 +661,5 @@
     CALL MPI_TYPE_COMMIT( type_xy, ierr )
 
-    IF ( TRIM( coupling_mode ) /= 'uncoupled' .AND. .NOT. vnested )  THEN
+    IF ( TRIM( coupling_mode ) /= 'uncoupled' )  THEN
    
 !
@@ -766,9 +761,4 @@
 
     ENDIF
-
-!
-!-- Store partner grid point co-ordinates as lists.
-!-- Create custom MPI vector datatypes for contiguous data transfer
-    IF ( vnested )  CALL vnest_init_pegrid_domain
 
 #else
Index: palm/trunk/SOURCE/local_stop.f90
===================================================================
--- palm/trunk/SOURCE/local_stop.f90	(revision 4562)
+++ palm/trunk/SOURCE/local_stop.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: misplaced cpp-directive moved
 ! 
@@ -57,4 +60,5 @@
 
     IF ( coupling_mode == 'uncoupled' )  THEN
+
        IF ( nested_run )  THEN
 !
@@ -72,11 +76,5 @@
           ENDIF
        ENDIF
-    ELSEIF ( coupling_mode(1:8) == 'vnested_' )  THEN
 
-       PRINT*, '+++ local_stop:'
-       PRINT*, '     model "', TRIM( coupling_mode ), '" terminated'
-!
-!--    Abort both coarse and fine grid
-       CALL MPI_ABORT( MPI_COMM_WORLD, 9999, ierr )
     ELSE
 
Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4562)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4564)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Adapt mass-flux correction also for the anelastic approximation
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Adapt mass-flux correction also for the anelastic approximation
+! 
+! 4561 2020-06-12 07:05:56Z suehring
 ! use statement for exchange horiz added
 ! 
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 4562)
+++ palm/trunk/SOURCE/parin.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4536 2020-05-17 17:24:13Z raasch
 ! bugfix for restart data format query
 ! 
@@ -146,7 +149,4 @@
     USE turbulence_closure_mod,                                                &
         ONLY:  rans_const_c, rans_const_sigma
-
-    USE vertical_nesting_mod,                                                  &
-        ONLY:  vnest_start_time
 
 
@@ -325,5 +325,5 @@
              skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,          &
              skip_time_do3d, skip_time_domask, synchronous_exchange,           &
-             termination_time_needed, vnest_start_time
+             termination_time_needed
 
     NAMELIST /runtime_parameters/  averaging_interval, averaging_interval_pr,  &
@@ -351,5 +351,5 @@
              skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,          &
              skip_time_do3d, skip_time_domask, synchronous_exchange,           &
-             termination_time_needed, vnest_start_time
+             termination_time_needed
 
     NAMELIST /envpar/  progress_bar_disabled, host,                            &
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4562)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4539 2020-05-18 14:05:17Z raasch
 ! location message added
 ! 
@@ -195,7 +198,4 @@
     USE user,                                                                                      &
         ONLY:  user_module_enabled
-
-    USE vertical_nesting_mod,                                                  &
-        ONLY:  vnest_init
 
     USE virtual_measurement_mod,                                               &
@@ -789,6 +789,4 @@
              CASE ( 'virtual_flight' )
                 READ ( 13 )  virtual_flight
-             CASE ( 'vnest_init' )
-                READ ( 13 )  vnest_init
              CASE ( 'volume_flow_area' )
                 READ ( 13 )  volume_flow_area
@@ -1129,5 +1127,4 @@
        CALL rrd_mpi_io_global_array( 'vg_vertical_gradient_level_ind', vg_vertical_gradient_level_ind )
        CALL rrd_mpi_io( 'virtual_flight', virtual_flight )
-       CALL rrd_mpi_io( 'vnest_init', vnest_init )
        CALL rrd_mpi_io_global_array( 'volume_flow_area', volume_flow_area )
        CALL rrd_mpi_io_global_array( 'volume_flow_initial', volume_flow_initial )
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4562)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4521 2020-05-06 11:39:49Z schwenkel
 ! Rename variable
 ! 
@@ -398,13 +401,4 @@
                usm_surface_energy_balance, usm_green_heat_model
 
-    USE vertical_nesting_mod,                                                                      &
-        ONLY:  vnested, vnest_init
-
-#if defined( __parallel )
-    USE vertical_nesting_mod,                                                                      &
-        ONLY:  vnest_anterpolate, vnest_anterpolate_e, vnest_boundary_conds,                       &
-               vnest_boundary_conds_khkm, vnest_deallocate, vnest_init_fine, vnest_start_time
-#endif
-
     USE virtual_measurement_mod,                                                                   &
         ONLY:  dt_virtual_measurement,                                                             &
@@ -616,5 +610,5 @@
 !-- Data exchange between coupled models in case that a call has been omitted
 !-- at the end of the previous run of a job chain.
-    IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled  .AND. .NOT. vnested )  THEN
+    IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
 !
 !--    In case of model termination initiated by the local model the coupler
@@ -636,17 +630,4 @@
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
-
-#if defined( __parallel )
-!
-!--    Vertical nesting: initialize fine grid
-       IF ( vnested ) THEN
-          IF ( .NOT. vnest_init  .AND.  simulated_time >= vnest_start_time )  THEN
-             CALL cpu_log( log_point_s(22), 'vnest_init', 'start' )
-             CALL vnest_init_fine
-             vnest_init = .TRUE.
-             CALL cpu_log( log_point_s(22), 'vnest_init', 'stop' )
-          ENDIF
-       ENDIF
-#endif
 
 !
@@ -868,12 +849,4 @@
 
 #if defined( __parallel )
-!
-!--       Vertical nesting: Interpolate fine grid data to the coarse grid
-          IF ( vnest_init ) THEN
-             CALL cpu_log( log_point_s(37), 'vnest_anterpolate', 'start' )
-             CALL vnest_anterpolate
-             CALL cpu_log( log_point_s(37), 'vnest_anterpolate', 'stop' )
-          ENDIF
-
           IF ( nested_run )  THEN
 
@@ -1033,43 +1006,18 @@
 !--       Reduce the velocity divergence via the equation for perturbation
 !--       pressure.
-          IF ( intermediate_timestep_count == 1  .OR. &
-                call_psolver_at_all_substeps )  THEN
-
-             IF (  vnest_init ) THEN
+          IF ( intermediate_timestep_count == 1  .OR.  call_psolver_at_all_substeps )  THEN
+
 #if defined( __parallel )
 !
-!--             Compute pressure in the CG, interpolate top boundary conditions
-!--             to the FG and then compute pressure in the FG
-                IF ( coupling_mode == 'vnested_crse' )  CALL pres
-
-                CALL cpu_log( log_point_s(30), 'vnest_bc', 'start' )
-                CALL vnest_boundary_conds
-                CALL cpu_log( log_point_s(30), 'vnest_bc', 'stop' )
-
-                IF ( coupling_mode == 'vnested_fine' )  CALL pres
-
-!--             Anterpolate TKE, satisfy Germano Identity
-                CALL cpu_log( log_point_s(28), 'vnest_anter_e', 'start' )
-                CALL vnest_anterpolate_e
-                CALL cpu_log( log_point_s(28), 'vnest_anter_e', 'stop' )
-#else
-                CONTINUE
+!--          Mass (volume) flux correction to ensure global mass conservation for child domains.
+             IF ( child_domain )  THEN
+                IF ( nesting_mode == 'vertical' )  THEN
+                   CALL pmci_ensure_nest_mass_conservation_vertical
+                ELSE
+                   CALL pmci_ensure_nest_mass_conservation
+                ENDIF
+             ENDIF
 #endif
-
-             ELSE
-#if defined( __parallel )
-!
-!--             Mass (volume) flux correction to ensure global mass conservation for child domains.
-                IF ( child_domain )  THEN
-                   IF ( nesting_mode == 'vertical' )  THEN
-                      CALL pmci_ensure_nest_mass_conservation_vertical
-                   ELSE
-                      CALL pmci_ensure_nest_mass_conservation
-                   ENDIF
-                ENDIF
-#endif
-                CALL pres
-
-             ENDIF
+             CALL pres
 
           ENDIF
@@ -1187,10 +1135,4 @@
              ENDIF
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
-
-#if defined( __parallel )
-!
-!--          Vertical nesting: set fine grid eddy viscosity top boundary condition
-             IF ( vnest_init )  CALL vnest_boundary_conds_khkm
-#endif
 
           ENDIF
@@ -1402,5 +1344,5 @@
 !
 !--    Data exchange between coupled models
-       IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled  .AND.  .NOT. vnested )  THEN
+       IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
           time_coupling = time_coupling + dt_3d
 
@@ -1741,10 +1683,4 @@
 !$ACC END DATA
 
-#if defined( __parallel )
-!
-!-- Vertical nesting: Deallocate variables initialized for vertical nesting
-    IF ( vnest_init )  CALL vnest_deallocate
-#endif
-
     IF ( myid == 0 )  CALL finish_progress_bar
 
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 4562)
+++ palm/trunk/SOURCE/timestep.f90	(revision 4564)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4540 2020-05-18 15:23:29Z raasch
 ! File re-formatted to follow the PALM coding standard
 !
@@ -135,10 +138,4 @@
                w_max,                                                                              &
                w_max_ijk
-
-#if defined( __parallel )
-    USE vertical_nesting_mod,                                                                      &
-        ONLY:  vnested,                                                                            &
-               vnest_timestep_sync
-#endif
 
     IMPLICIT NONE
@@ -413,10 +410,4 @@
     ENDIF
 
-#if defined( __parallel )
-!
-!-- Vertical nesting: coarse and fine grid timestep has to be identical
-    IF ( vnested )  CALL vnest_timestep_sync
-#endif
-
     CALL cpu_log( log_point(12), 'calculate_timestep', 'stop' )
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4562)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4564)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting method of Huq et al. (2019) removed
+! 
+! 4536 2020-05-17 17:24:13Z raasch
 ! binary version incremented
 ! 
@@ -143,7 +146,4 @@
         ONLY:  user_module_enabled
 
-    USE vertical_nesting_mod,                                                                      &
-        ONLY:  vnest_init
-
     USE virtual_measurement_mod,                                                                   &
         ONLY:  time_virtual_measurement
@@ -839,7 +839,4 @@
        CALL wrd_write_string( 'virtual_flight' )
        WRITE ( 14 )  virtual_flight
-
-       CALL wrd_write_string( 'vnest_init' )
-       WRITE ( 14 )  vnest_init
 
        CALL wrd_write_string( 'volume_flow_area' )
@@ -1122,5 +1119,4 @@
        CALL wrd_mpi_io_global_array( 'vg_vertical_gradient_level_ind', vg_vertical_gradient_level_ind )
        CALL wrd_mpi_io( 'virtual_flight', virtual_flight )
-       CALL wrd_mpi_io( 'vnest_init', vnest_init )
        CALL wrd_mpi_io_global_array( 'volume_flow_area', volume_flow_area )
        CALL wrd_mpi_io_global_array( 'volume_flow_initial', volume_flow_initial )
